<template>
  <div class="relative mb-5 flex items-center gap-x-2.5">
    <input v-model="searchQuery" class="input-field flex-grow" placeholder="Search..." @input="handleSearch" />
    <label for="create-item" class="bg-cyan text-white border border-solid border-white/25 rounded drop-shadow-20 p-2.5 inline-flex items-center justify-center hover:bg-cyan-800 hover:cursor-pointer">
      <button class="p-0 h-5" id="create-item" @click="createNewItem">
        <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" fill="none" viewBox="0 0 24 24" stroke="white">
          <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M12 4v16m8-8H4" />
        </svg>
      </button>
    </label>
  </div>
  <div v-bind="containerProps" class="flex-1 overflow-y-auto relative p-2.5 rounded-md default-border bg-gray" @scroll="onScroll">
    <div v-bind="wrapperProps" ref="elementToScroll" class="flex flex-col gap-2.5">
      <a v-for="{ data: item } in list" :key="item.id" class="relative p-2.5 cursor-pointer block rounded hover:bg-cyan group" :class="{ 'bg-cyan': assetManagerStore.selectedItem?.id === item.id }" @click="assetManagerStore.setSelectedItem(item as Item)">
        <div class="flex items-center gap-2.5">
          <span class="group-hover:text-white" :class="{ 'text-white': assetManagerStore.selectedItem?.id === item.id }">
            {{ item.name }}
            <small class="text-gray-400">({{ item.itemType }})</small>
          </span>
        </div>
      </a>
    </div>
    <div class="absolute w-12 h-12 bottom-2.5 right-2.5">
      <button class="fixed min-w-[unset] w-12 h-12 rounded-md bg-cyan p-0 hover:bg-cyan-800" v-show="hasScrolled" @click="toTop">
        <img class="invert w-8 h-8 center-element rotate-180" src="/assets/icons/mapEditor/chevron.svg" alt="" />
      </button>
    </div>
  </div>
</template>

<script setup lang="ts">
import type { Item } from '@/application/types'
import { useAssetManagerStore } from '@/stores/assetManagerStore'
import { useGameStore } from '@/stores/gameStore'
import { useVirtualList } from '@vueuse/core'
import { computed, onMounted, ref } from 'vue'

const gameStore = useGameStore()
const assetManagerStore = useAssetManagerStore()

const searchQuery = ref('')

const hasScrolled = ref(false)
const elementToScroll = ref()

const handleSearch = () => {
  virtualList.value?.scrollTo(0)
}

const createNewItem = () => {
  gameStore.connection?.emit('gm:item:create', {}, (response: boolean) => {
    if (!response) {
      console.error('Failed to create new item')
      return
    }

    gameStore.connection?.emit('gm:item:list', {}, (response: Item[]) => {
      assetManagerStore.setItemList(response)
    })
  })
}

const filteredItems = computed(() => {
  if (!searchQuery.value) {
    return assetManagerStore.itemList
  }
  return assetManagerStore.itemList.filter((item) => item.name.toLowerCase().includes(searchQuery.value.toLowerCase()) || item.itemType.toLowerCase().includes(searchQuery.value.toLowerCase()))
})

const { list, containerProps, wrapperProps, scrollTo } = useVirtualList(filteredItems, {
  itemHeight: 48
})

const virtualList = ref({ scrollTo })

const onScroll = () => {
  let scrollTop = elementToScroll.value.style.marginTop.replace('px', '')

  if (scrollTop > 80) {
    hasScrolled.value = true
  } else if (scrollTop <= 80) {
    hasScrolled.value = false
  }
}

function toTop() {
  virtualList.value?.scrollTo(0)
}

onMounted(() => {
  gameStore.connection?.emit('gm:item:list', {}, (response: Item[]) => {
    assetManagerStore.setItemList(response)
  })
})
</script>
